module Main where

import System.Environment(getArgs)

fac1 :: Integer-> Integer
fac1 n  = if n == 0 then 1 else n * fac1 (n-1) 

fac2 :: Integer-> Integer
fac2 n     = fac' n 1 where
  fac' :: Integer-> Integer-> Integer
  fac' n acc = if n == 0 then acc 
               else fac' (n-1) (n*acc)

fac3 :: Integer-> Integer
fac3 n = fac' n 1 where 
  fac' n acc = seq acc $ if n == 0 then acc 
                         else fac' (n-1) (n*acc)

main :: IO ()
main = do
  [flag, num] <- getArgs 
  let fun = case flag of "1" -> fac1
                         "2" -> fac2
                         "3" -> fac3
  putStrLn $ fun (read num) `seq`  "Done"
  
